#
/*
 * login [ name ]
 */

struct	{
	char	minor;
	char	major;
	int	inumber;
	int	flags;
	char	links;
	char	uid;
	char	gid;
	char	size0;
	int	size1;
	int	addr[8];
	int	actime[2];
	int	mtime[2];
	} stats;
struct	{
	char	name[8];
	char	tty;
	char	ifill;
	int	time[2];
	int	ufill;
} utmp;

struct {
	int	regs[2];
	int	tflags;
} ttyb;

int tvec[2];


#define	ECHO	010

main(argc, argv)
char **argv;
{
	int fm, cm[2];
	char pbuf[128];
	register char *namep, *np;
	char pwbuf[9];
	int t, sflags, f, c, uid, gid,i;
	int pwcnt;
	int status;
	char *pw;

	signal(3, 1);
	signal(2, 1);
	if((utmp.tty=ttyn(0)) != 'x') goto sorry;
    loop:
	namep = utmp.name;
	if (argc>1) {
		np = argv[1];
		while (namep<utmp.name+8 && *np)
			*namep++ = *np++;
		argc = 0;
	} else {
		goto sorry;
		}
	while (namep < utmp.name+8)
		*namep++ = ' ';
	if (getpwentry(utmp.name, pbuf))
		goto bad;
	np = colon(pbuf);
	if (*np!=':') {
		pwcnt=0;
		pw=np; /* save password pointer */
	askpw:
		namep = pwbuf;
		while ((c=mychar()) != '\n') {
			if (c <= 0)
				exit();
			if (namep<pwbuf+8)
				*namep++ = c;
		}
		*namep++ = '\0';
		namep = crypt(pwbuf);
		while (*namep++ == *np++);
		if (*--namep!='\0' || *--np!=':')
			{write(1,"Password incorrect.",20);
			goto sorry;
			};
	}
	np = colon(np);
	uid = 0;
	while (*np != ':')
		uid = uid*10 + *np++ - '0';
	np++;
	gid = 0;
	while (*np != ':')
		gid = gid*10 + *np++ - '0';
	np++;
	np = colon(np);
	namep = np;
	np = colon(np);
	if (chdir(namep)<0) {
		write(1, "No directory\n", 13);
		goto loop;
	}
	time(utmp.time);
	if ((f = open("/usr/adm/wtmp", 1)) >= 0) {
		seek(f, 0, 2);
		write(f, &utmp, 16);
		close(f);
	}

	setgid(gid);
	setuid(uid);
	if (*np == '\0')
		np = "/etc/bpipe";

	if(pipe(cm)== -1){perror("blogin");exit(-1);}
	if((fm = fork())== -1){perror("blogin");exit(-1);}
	if(!fm){close(0); dup(cm[0]); close(cm[0]); close(cm[1]);
		execl("/bin/lpr","lpr",0); 
		}

	close(2); dup(cm[1]);
	close(1); dup(cm[1]); close(cm[1]); close(cm[0]);

	write(1,"batch login: ",13); write(1,utmp.name,8);
	putchar('\n');

	if ((f = open("/etc/motd", 0)) >= 0) {
		while(read(f, &t, 1) > 0)
			write(1, &t, 1);
		close(f);
	}
	if ((stat(".mail", &stats) >=0) && (stats.size0  || stats.size1)) {
		write(1, "You have mail.\n", 15);
	}

		execl("/etc/bpipe","bpipe",0);
		exit();
badpw:
	write(1,"\n",1);
bad:
sorry:
	write(1, "Login incorrect.\n", 17);
	seek(0,0,2); /* to end of file */
	exit();
}

getpwentry(name, buf)
char *name, *buf;
{
	extern fin;
	int fi, r, c;
	register char *gnp, *rnp;

	fi = fin;
	r = 1;
	if((fin = open("/etc/passwd", 0)) < 0)
		goto ret;
loop:
	gnp = name;
	rnp = buf;
	while((c=getchar()) != '\n') {
		if(c <= 0)
			goto ret;
		*rnp++ = c;
	}
	*rnp++ = '\0';
	rnp = buf;
	while (*gnp++ == *rnp++);
	if ((*--gnp!=' ' && gnp<name+8) || *--rnp!=':')
		goto loop;
	r = 0;
ret:
	close(fin);
	fin = 0;
	(&fin)[1] = 0;
	(&fin)[2] = 0;
	return(r);
}

colon(p)
char *p;
{
	register char *rp;

	rp = p;
	while (*rp != ':') {
		if (*rp++ == '\0') {
			write(1, "Bad /etc/passwd\n", 16);
			exit();
		}
	}
	*rp++ = '\0';
	return(rp);
}
mychar()
{
char c;
if( read(0,&c,1)<=0) return(0);
return(c);
}
