#include	"hsh.h"

/*
 *	the first entries in database are position dependent
 *	(see switch @ doit:)
 *	 ***** change PDARGN to reflect any additions 
 *		or removals *****
 */

int	database[];





char	statbuf[36], *lfiles[11];
char	*argptr, *retyppnt, *rtbptr;
char	savechar, lastchar, linbuf[100];/*tty stuff*/
char	*linptr   linbuf;
char	hvdshf, nrmlsh, rawmdf, inushf, debugf, spcflg, uxcall;	/*flags*/

int	*srchlst;
int	ttiputsize 99;
int	usharg[] { "sh", 0, };
int	id_father, id_myown;

struct	{ char low; char high; };

char	delims[] { ESC,'\n','\r',' ',',',RUBOUT,04,BELL,0 };
		/*	breakcs must end with 0377	*/
char	breakcs[] { ESC,'\n','\r',0,04,BELL,RUBOUT,0377 };

int	hshsrchl[] {
	"/hshbin/",
	0,
};
int shsrchl[] {
	"",
	"/bin/",
	0,
};



main(argc, argv)
char *argv[];
{
	register int *cp, *dp, filmod;
	int nargs,argn,command,sttmode[3];
	int trebuf[16], savtime[4], dpair[2];
	char quiet, dshcnt, c1, c2, *chp;
	char	whichbuf;		/*remembered arguments*/
	char	cmd1buf[LBSIZE], cmd2buf[LBSIZE], retypbuf[RTSIZE];
	int	*files, myuid;
	char	*mynamep;
	extern	hangup();

	signal(1, hangup);
	dpair[0] = 0;
	mynamep = argv[0];
	myuid = getuid();
	uxcall = shtype(myuid);
	while(mynamep && *mynamep) *mynamep++ = 0;
	mynamep = argv[0];
	if(id_father != 1) mynamep[1] = '>';
	rtbptr = retypbuf;
	if(argc > 1 || equal(argv[0], "sh")) {
		nrmlsh = 1;
		inushf = 1;
		*mynamep = '-';
		mainush(argc, argv);
		exit();
	}
	if(ttyn(0) == 'x') nrmlsh = 1;
	cp = savtime;
	*cp++ = 0; *cp++ = 0; *cp++ = 0; *cp = 0;
	trebuf[0] = 1;		/* simple prog run command to ush */
	cp = &trebuf[1];
	*cp++ = 0; *cp++ = 0; *cp++ = 0; *cp = 0;
	whichbuf = 0;
	gtty(1, sttmode);
	initx();
	if(id_father == 1 && !uxcall)
		type("-HSH- Type ? for help\n");
	goto nxtcmd;
retry:	type("@@@");
	if(quiet && lastchar != ESC) type("\n");
retryx:	while(!breakc(lastchar)) read1(&c1);
retryy:	if((quiet && lastchar != '\r' && lastchar != '\n')
			|| ((!quiet) && lastchar != '\n'))
		type("\n");
nxtcmd:	if(!quiet) {
		sttmode[2] =| RAW;
		stty(1, sttmode);
		rawmdf = 1;
	} else {
		sttmode[2] =| DDT;
		sttmode[2] =& ~RAW;
		stty(1, sttmode);
		rawmdf = 0;
	}
	savechar = 0;
	srchlst = hshsrchl;
	retyppnt = &retypbuf;
	*retyppnt = 0;
	if(uxcall)goto uxshell;
	if(id_father != 1) type(">");
	if(myuid)
		if(quiet) {
			*mynamep = '=';
			type("= " );
		} else {
			*mynamep = '@';
			type("@ ");
		}
	else
		if(quiet) {
			*mynamep = ':';
			type(": ");
		} else {
			*mynamep = '!';
			type("! ");
		}
	if(read1(&c1)==0) goto retryy;
	if(c1 == '%' || c1 == '.') {
		sttmode[2] =& ~RAW;
		sttmode[2] =| DDT;
		stty(1, sttmode);
		if(getline(rtbptr, c1))
			goto oldsh;
		goto retry;
	}
	if(c1 == ';') {
		sttmode[2] =& ~RAW;
		sttmode[2] =| DDT;
		stty(1, sttmode);
		goto retryx;
	}
	if(c1 == '?') {
		if(!quiet) {
			sttmode[2] =& ~RAW;
			stty(1, sttmode);
		}
		listcmds();
		if(!quiet) lastchar = 0;
		goto retryx;
	}
	if(c1 == 01) {
		debugf =^ 1;
		goto retryy;
	}
	if(delim(c1) || breakc(c1))
		goto retryy;
	if(read1(&c2)==0) goto retry;
	if(delim(c2) || breakc(c2)) {
		lastchar = 0;
		goto retry;
	}
	if(!quiet) {
		sttmode[2] =& ~RAW;
		sttmode[2] =| DDT;
		stty(1, sttmode);
		rawmdf = 0;
	}
	dp = &database;
	command = 0;
	for(;;) {
		cp = *dp++;
		if(cp == 0) {
			if( (c1 >= 'A' && c1 <= 'Z') ||
			  (c2 >= 'A' && c2 <= 'Z'))
				type(" (try lower case)");
			type(" [unrecognizable command]");
			if(quiet) {
				type("\n");
				goto retryx;
			} else
				goto retryy;
		}
		if(c1 == cp->low && c2 == cp->high) break;
		dp++;
		command++;
	}
	retyppnt = movestrng(cp, retyppnt) - 1;
	cp++;
	if(!quiet)
		type(cp);
	else {
		if(trlmtch(cp)==0) {
			type(" \""); type(&c1); type(&c2);
			type("\" I recognize; but the rest doesn't match \"");
			type(--cp); type("\". ");
			goto retry;
		}
	}
	cp = *dp;
	nargs = *cp++;
	argn = 0;
	spcflg = 0;
	files = trebuf + 6;
	if(whichbuf)
		argptr = cmd2buf;
	else
		argptr = cmd1buf;
	trebuf[5] = argptr;
	argptr = movestrng(retypbuf, argptr);
	if(command == 0 && id_father == 1) type(" [logout]");
	dshcnt = 0;
more:	if(!quiet && lastchar != ' ' && lastchar != ',' && *cp)
		typer(*cp);
	if(*cp) { cp++; filmod = *cp++; }
	if(quiet && (filmod&REQRD)==0 && breakc(lastchar))
		goto doit;
	spcflg =| filmod&SPCL;
	if(filmod&AUTO)
autogo:		if(filmod&CONFIRM)
			goto confirm;
		else
			goto doit;
	files[argn] = argptr;
	if(! getfil(files[argn]))
		if(filmod&REQRD)
			goto retry;
		else
			if(lastchar == ESC || lastchar == '\r' ||
						lastchar == '\n')
				goto doit;
			else
				goto retry;
	retyppnt = movestrng(files[argn], retyppnt) - 1;
	if(filmod & DSHALWD)
		if(files[argn]->low == '-') {
			dshcnt++;
			goto next;
		}
	if(filmod & EXST) {
		if(wild(files[argn])) {
			if(!quiet && (filmod&(REQRD|CONFIRM))==(REQRD|CONFIRM))
				typer(" [*wild*] ");
			goto next;
		}
		if(! exists(files[argn])) {
			type(" [non-existent] ");
retryz:			if(quiet) {
				type(files[argn]);
				type(" ");
			}
			if(!quiet)
				while(!breakc(lastchar)) read1(&c1);
			goto retry;
		}
		goto next;
	}
	if(filmod & NEW_OLD) {
		if(wild(files[argn])) {
			type(" [wild not allowed] ");
			goto retryz;
		}
		if(exists(files[argn])) {
			if(!quiet) typer(" [old file]");
		} else {
			if(!quiet) typer(" [new file]");
		}
		goto next;
	}
	if(filmod & NOEXST) {
		if(exists(files[argn])) {
			type(" [already exists] ");
			goto retryz;
		}
	}
next:	argn++;
	if(lastchar == ESC || lastchar == '\r' || lastchar == '\n') {
		if(! (filmod&REQRD)) goto doit;
		if(filmod&DSHALWD && dshcnt == argn) goto more;
		if(filmod&CONFIRM) goto confirm;
		if(filmod&QOB) goto autogo;
	} else {
		if(argn == nargs) {
			type(" [syntax error: too many args] ");
			goto retry;
		}
		if(argn >= ARGLIM) {
			type(" [Arg limit reached; use unix shell] ");
			goto retry;
		}
	}
	if(argn == nargs)
nexta:		if(filmod&CONFIRM)
			goto confirm;
		else
			goto doit;
	goto more;

confirm: if(!quiet) {
		typer(" [confirm]");
con1:		if(read1(&c1) == 0) goto retry;
		if(c1 == RUBOUT) goto con1;
		if(c1 == '\n' || c1 == ESC || c1 == '\r') goto doit;
		goto retry;
	}
doit:	
	nargs = argn;
	while (nargs <10) files[nargs++] = 0;
	if(!spcflg)
		if(argn) {
			for(nargs = 0; nargs < 10; nargs++)
				lfiles[nargs] = trebuf[nargs+5];
			whichbuf =^ 1;
		}
	if(lastchar != '\n' && lastchar != '\r')
		type("\n");
	if(command > PDARGN) goto executit;
	switch(command) {
		case 0:
logoff:			sttmode[2] =& ~(RAW | DDT);
			stty(1, sttmode);
			hangup();
		case 1: quiet = 1;
			goto nxtcmd;
		case 2: quiet = 0;
			goto nxtcmd;
		case 3:
uxshell:
			hvdshf = 0;
oldsh:			sttmode[2] =& ~(RAW | DDT);
			stty(1, sttmode);
			rawmdf = 0;
			inushf = 0;
			*mynamep = '%';
			mainush(1, usharg);
			if(hvdshf == -1) goto logoff;
			uxcall=0;
			gtty(1, sttmode);
			sttmode[2] =& ~RAW;
			sttmode[2] =| DDT;
			stty(1, sttmode);
			hvdshf = 1;
			lastchar = 0;
			goto nxtcmd;
		case 4:	times(&trebuf[5]);
			dpair[1] = trebuf[5];
			dppadd(dpair, trebuf+7);
			dpair[1] = trebuf[6];
			dppadd(dpair, trebuf+9);
			cp = trebuf+7;
			dp = trebuf+11;
			*dp++ = *cp++; *dp++ = *cp++;
			*dp++ = *cp++; *dp = *cp;
			dppsub(savtime, trebuf+11);
			dppsub(savtime+2, trebuf+13);
			prntime(trebuf+11);
			type(" - ");
			prntime(trebuf+13);
			type("\n");
			cp = trebuf+7;
			dp = savtime;
			*dp++ = *cp++; *dp++ = *cp++;
			*dp++ = *cp++; *dp = *cp;
			prntime(savtime);
			type(" - ");
			prntime(savtime+2);
			type("\n");
			goto nxtcmd;
		case 5:	nargs = 5;
			while(nargs != argn+5) {
				trebuf[nargs] = trebuf[nargs+1];
				nargs++;
			}
			trebuf[nargs] = 0;
			srchlst = shsrchl;
			goto executit;
		case 6:	if(!argn) {
				trebuf[5] = "pwd";
				trebuf[6] = 0;
				type("current directory=");
				goto executit;
			}
			if(chdir(files[0]) < 0)
				type(" [bad directory]\n");
			goto nxtcmd;
		case 7: nargs = argn + 5;
			trebuf[nargs+2] = 0;
			while(nargs != 5) {
				trebuf[nargs+1] = trebuf[nargs];
				nargs--;
			}
			trebuf[6] = "-l";
			goto executit;
	}
executit:
	sttmode[2] =& ~(RAW|DDT);
	stty(1, sttmode);
	rawmdf = 0;
	execute(trebuf);
	gtty(1, sttmode);
	goto nxtcmd;
}



type(s)							/* type */
char *s;
{
	register int sum;
	char *p;

	p = s;
	sum = 0;
	while(*p++) sum++;
	write(2, s, sum);
}



typer(s)						/* typer */
char *s;
{
	retyppnt = movestrng(s, retyppnt) - 1;
	type(s);
}



getfil(s)						/* getfil */
char *s;
{
	char c;
	int flag;

	flag = 0;
	while(read1(&c)) {
		if(c == RUBOUT) continue;
		if(delim(c)) {
			if(flag) {
				*s++ = 0;
				argptr = s;
				return(1);
			} else {
				if(c == ' ') continue;
				return(0);
			}
		}
		*s++ = c;
		flag++;
	}
}



delim(ch)						/* delim */
char ch;
{
	register char *p;

	p = delims;
	while(*p)
		if(*p++ == ch) return(1);
	return(0);
}



breakc(ch)						/* breakc */
char ch;
{
	register char *p;

	p = breakcs;
	while(*p>=0)
		if(*p++ == ch) return(1);
	return(0);
}



exists(filstrng)					/* exists */
char *filstrng;
{
	if(stat(filstrng, statbuf)<0)
		return(0);
	else
		return(1);
}



read1(cc)						/* read1 */
char *cc;
{
	register int tmp;
	register char *ptr;
	register char c;

	if(savechar) {
		lastchar = savechar;
		savechar = 0;
		goto ret;
	}
	ptr = linbuf;
a:	if((lastchar = *linptr++)) goto ret;
b:	tmp = read(0, ptr, ttiputsize-(ptr-linbuf));
	tmp =+ ptr - linbuf;
	if(tmp) {
		linbuf[tmp--] = 0;
		if(linbuf[tmp] == RUBOUT)
			if(!rawmdf || tmp > 0) {
				linbuf[tmp--] = 0;
				if(tmp < 0) goto b;
				ptr = &linbuf[tmp];
				type(ptr);
				goto b;
			}
		if(linbuf[tmp] == CKILL || linbuf[tmp] == BELL) {
			lastchar = 0;
			linptr = linbuf;
			*linptr = 0;
			if(inushf)
				goto b;
			else {
				*cc = 04;
				return(0);
			}
		}
		if(linbuf[tmp] == RETYPE) {
			ptr = &linbuf[tmp];
			*ptr = 0;
			type(rtbptr);
			type(linbuf);
			goto b;
		}
		if(linbuf[tmp] == '^' && rawmdf == 0 && inushf == 0) {
			c = linbuf[--tmp];
			if(c >= '0' && c <= '9')
				c =- '0';
			else {
				c = 1;
				tmp++;
			}
			if(lfiles[c]) {
				type(lfiles[c]);
				ptr = movestrng(lfiles[c], &linbuf[tmp]) - 1;
			} else {
				type("");
				ptr = &linbuf[tmp];
			}
			goto b;
		}
		linptr = linbuf;
		goto a;
	}
	lastchar = 0;
	linptr = linbuf;
	*linptr = 0;
	if(debugf) type("'null'");
	return(0);
ret:	lastchar =& 0177;
	*cc = lastchar;
	if(debugf) { type("'");prn(lastchar);type("'"); }
	return(lastchar);
}



trlmtch(s)						/* trlmtch */
char *s;
{
	char c;

a:	if(read1(&c)==0) return(1);
	if(delim(c) || breakc(c)) {
		savechar = c;
		return(1);
	}
	if(*s++ != c) return(0);
	goto a;
}



wild(s)							/* wild */
char *s;
{

	while(*s)
		if(any(*s++, "[?*")) return(1);
	return(0);
}



listcmds()						/* listcmds */
{
	register char *s;
	register int *p, i;

	p = database;
	i = 0;
	type("\nType \"he commands\" for further help.\n");
	type("Current commands are:\n");
	while(*p) {
		s = *p;
		if(*s < 'a') goto nxt;
		if((i%5) == 4) {
			type(*p); type("\n");
		} else
			type14(*p);
		i++;
nxt:		p =+ 2;
	}
	if((i%5) != 4)
		type("\n");
	return;
}



type14(s)						/* type14 */
char *s;
{
	char b[12];
	register char *p;

	b[11] = 0;
	p = b;
	while(p != b+11) *p++ = ' ';
	p = b;
	while(*s)
		*p++ = *s++;
	type(b);
}



initx()							/* initx */
{
	hvdshf = 1;
	rawmdf = 0;
	debugf = 0;
	*linptr++ = '\n';
	*linptr-- = 0;
	savechar = 0;
	mainush(1, usharg);
	lastchar = ESC;
}



movestrng(s1,s2)					/* movestrng */
char *s1, *s2;
{
	do *s2++ = *s1++; while *s1;
	*s2++ = 0;
	return(s2);
}



getline(bp, ch)						/* getline */
char *bp;
{
	register char *cp;
	char c;

	rawmdf = 1;
	cp = bp;
	*cp++ = ch;
	*cp = 0;
loop:	read1(&c);
	*cp++ = c;
	*cp = 0;
	if(!breakc(c))
		goto loop;
	switch(c) {
		case 04:	return(0);
		case RUBOUT:	--cp;
				type(--cp);
				*cp = 0;
				if(cp == bp) return(0);
				goto loop;
		case '\n':
		case '\r':	linptr = ++bp;
				return(1);
	}
	goto loop;
}



prntime(n)						/* prntime */
int *n;
{
	register int i,j,k;

	i = ldiv(n[0], n[1], 60*60);
	j = lrem(n[0], n[1], 60*60);
	k = j % 60;
	j =/ 60;
	k =* 100;
	k =+ 30;
	k =/ 60;
	if(i) {
		prn(i);
		type(":");
	}
	if(i || j) {
		if(i && j<10) type("0");
		prn(j);
	}
	type(".");
	if(k<10) type("0");
	prn(k);
}


hangup()						/* hangup */
{
	register char *cp;
/*
	if(id_father == 1) {
		cp = BYENAME;
		execl(cp,cp,"-q",0);
		type("?? Can't exec logout ??\n");
	}
*/
	exit();
}

shtype(uid)
{
	register char t;
	char choice;

	choice = 0;
	if((t=open("/etc/shtypes",0)) < 0)return(0);
	seek(t,uid&0377,0);
	read(t,&choice,1);
	close(t);
	return(choice);
}

/* Temp adds to make dppadd and dppsub dummies */
dppadd(a,b)
{
	return;
}

dppsub(a,b)
{
	return;
}
